<html><head><title>3d image wizard</title></head>
<body><p>
<?

function checkUploadedImage($img) {
    if (!is_uploaded_file($img)) return "Didn't get that image. Are you sure your filesizes are under the limit?";
    if (mime_content_type($img)!="image/jpeg") return "Not a jpeg image!";
    return "";
}


//Routine to convert multiple imput images into a 3d image
//with width px and height py
//args: input files[8], output file, result_w, result_h
function make3dImage($pics, $out, $px, $py) {
    $dx=count($pics); //number of images / angles
    $px=$px/$dx;

    $i=imagecreatetruecolor(($px+2)*$dx,$py);

    $mox=intval($dx/2);
    for ($ox=-$mox; $ox<=$mox; $ox++) {
	$n=((count($pics)/2)+$ox)%$dx;
	
	@$sp=imagecreatefromjpeg($pics[$n]);
	if ($sp=="") return("File ".($n+1)." doesn't seem to be a valid jpeg file.");
	$s=imagecreatetruecolor($px,$py);
	imagecopyresampled($s,$sp,0,0,0,0,$px,$py,imagesx($sp),imagesy($sp));
	imagedestroy($sp);
	for ($x=0; $x<imagesx($s); $x++) {
	    for ($y=0; $y<imagesy($s); $y++) {
		$c=imagecolorat($s,$x,$y);
		imagesetpixel($i,($x+1)*$dx-$ox,$y,$c);
	    }
	}
	imagedestroy($s);
    }
    imagepng($i,$out);
    return "";
}

//First, check if all images came over OK
for ($x=0; $x<8; $x++) {
    $err=checkUploadedImage($_FILES['image']['tmp_name'][$x]);
    if ($err!="") {
	echo "Error: Image ".($x+1).": $err";
	echo '</p></html>';
	exit(0);
    }
}

//Make a dir to permanently store the images
$name=md5(gettimeofday(true));
$dir="uploaded/".$name;
$outDir="results/";
mkdir($dir);


//Then, upload images to its own dir
for ($x=0; $x<8; $x++) {
    $image[$x]="$dir/".str_replace('/', '', $_FILES['image']['name'][$x]);
    move_uploaded_file($_FILES['image']['tmp_name'][$x], $image[$x]);
}

//Generate a thumbnail
$p=imagecreatefromjpeg($image[4]);
$th=imagecreatetruecolor(320,240);
imagecopyresampled($th,$p,0,0,0,0,320,240,imagesx($p),imagesy($p));
imagejpeg($th,$outDir.$name."-tmb.jpg");
imagedestroy($p);
imagedestroy($th);

//Finally, generate a bunch of 3d images.

$err=make3dImage($image, $outDir.$name."-800x600.png", 800, 600);
if ($err!="") {
    echo $err;
    exit(0);
}
$err=make3dImage($image, $outDir.$name."-1024x600.png", 1024, 600);
$err=make3dImage($image, $outDir.$name."-320x240.png", 320, 240);
$err=make3dImage($image, $outDir.$name."-1024x786.png", 1024, 786);
$err=make3dImage($image, $outDir.$name."-1280x1024.png", 1280, 1024);

echo "All done. Get it while it's hot :)<br>";
echo '<a href="'.$outDir.$name.'-320x240.png">320x240</a><br>';
echo '<a href="'.$outDir.$name.'-800x600.png">800x600</a><br>';
echo '<a href="'.$outDir.$name.'-1024x600.png">1024x600</a><br>';
echo '<a href="'.$outDir.$name.'-1024x786.png">10240x786</a><br>';
echo '<a href="'.$outDir.$name.'-1280x1024.png">1280x1024</a><br>';

if ($_REQUEST["desc"]!="") {
    $rec="$name:".htmlentities($_REQUEST['desc'])."\n";
    $f=fopen("public.txt", "a");
    fputs($f, $rec);
    fclose($f);
}

?>
</p>
</html>
